/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Gareth Johnson
 */

/**
 * Defines {@link baja.Host}.
 * @module baja/comp/Host
 */
define(["bajaScript/nav"], function (baja) {
  
  "use strict";
  
  var subclass = baja.subclass,
      callSuper = baja.callSuper;
  
  /**
   * Represents a `baja:Host` in BajaScript.
   * 
   * @class
   * @alias baja.Host
   * @extends baja.NavContainer
   */  
  var Host = function Host() { 
    callSuper(Host, this, arguments);
  };
  
  subclass(Host, baja.NavContainer);
  
  /**
   * Return a `Host`'s Nav ORD.
   *
   * @private
   *
   * @returns {baja.Ord}
   */
  Host.prototype.getNavOrd = function () {
    return this.getAbsoluteOrd();
  };
  
  /**
   * Return a `Host`'s Absolute ORD.
   *
   * @private
   *
   * @returns {baja.Ord}
   */
  Host.prototype.getAbsoluteOrd = function () {
    return null;
  };
  
  return Host;
});