/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Gareth Johnson
 */

/**
 * Defines {@link baja.LocalHost}.
 * @module baja/comp/LocalHost
 */
define(["bajaScript/nav",
        "bajaScript/baja/comp/Host"], 
        function (baja, Host) {
  
  "use strict";
  
  var subclass = baja.subclass,
      callSuper = baja.callSuper;
  
  /**
   * Represents a `baja:LocalHost` in BajaScript.
   *
   * @class
   * @alias baja.LocalHost
   * @extends baja.Host
   */  
  var LocalHost = function LocalHost() { 
    callSuper(LocalHost, this, [{
      navName: "localhost",
      icon: "module://icons/x16/localhost.png"
    }]);
  };
  
  subclass(LocalHost, Host);
  
  /**
   * Return a Local Host's Absolute ORD.
   *
   * @private
   *
   * @returns {baja.Ord}
   */
  LocalHost.prototype.getAbsoluteOrd = function () {
    return baja.Ord.make("local:");
  };
  
  return LocalHost;
});