/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * A module that displays a paged table of alarms from an alarm database
 * @module nmodule/alarm/rc/db/DatabaseView
 * @private
 */
define(['nmodule/alarm/rc/db/DatabaseMaintenance', 'underscore'],
  function (DatabaseMaintenance, _) {

    "use strict";

    var DatabaseView = function DatabaseView(params) {
      params = params || {};

      DatabaseMaintenance.call(this, _.extend({
        moduleName: 'alarm',
        keyName: 'DatabaseView'
      }, params));
    };

    //extend and set up prototype chain
    DatabaseView.prototype = Object.create(DatabaseMaintenance.prototype);
    DatabaseView.prototype.constructor = DatabaseView;

    DatabaseView.prototype.isMaintenanceView = function () {
      return false;
    };

    return DatabaseView;
  });
