function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @copyright 2016 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * MoveUpCommand
 * @module nmodule/webEditors/rc/wb/composite/commands/MoveUpCommand
 * @private
 */

define(['baja!', 'jquery', 'lex!workbench', 'Promise', 'underscore', 'bajaux/commands/Command'], function (baja, $, lexs, Promise, _, Command) {

  'use strict';

  function handleMoveUp(cmd, editor) {
    var table = editor.$getTable(),
        selection = table.$getSelection(),
        model = table.value(),
        rows = model.getRows(),
        selectedRows = selection.getSelectedElements(rows),
        reorderedRows = [];

    if (selectedRows.length > 0) {

      _.each(selectedRows, function (row) {
        var index = model.getRowIndex(row),
            newIndex = index - 1;

        if (newIndex >= 0 && !selection.isSelected(newIndex)) {
          var src = row.getSubject(),
              target = rows[newIndex].getSubject(),
              temp = _.clone(target);

          //copy source to target
          for (var prop in src) {
            if (src.hasOwnProperty(prop)) {
              target[prop] = src[prop];
            }
          }

          //copy temp to source
          for (var _prop in temp) {
            if (temp.hasOwnProperty(_prop)) {
              src[_prop] = temp[_prop];
            }
          }

          selection.put(index, false);
          selection.put(newIndex, true);
          reorderedRows.push(rows[index], rows[newIndex]);
        }
      });

      if (reorderedRows.length > 0) {
        model.emit('rowsReordered', reorderedRows);
      }
    }
  }

  /**
   * MoveUpCommand
   *
   * @class MoveUpCommand
   * @extends module:bajaux/commands/Command
   * @alias module:nmodule/webEditors/rc/wb/composite/commands/MoveUpCommand
   * @private
   */

  var MoveUpCommand = function (_Command) {
    _inherits(MoveUpCommand, _Command);

    function MoveUpCommand(editor) {
      var _this;

      _classCallCheck(this, MoveUpCommand);

      return _this = _possibleConstructorReturn(this, (MoveUpCommand.__proto__ || Object.getPrototypeOf(MoveUpCommand)).call(this, {
        module: "workbench",
        lex: 'compositeEditor.moveUp',
        enabled: false,
        func: function func() {
          return handleMoveUp(_this, editor);
        }
      }));
    }

    return MoveUpCommand;
  }(Command);

  return MoveUpCommand;
});
