/**
 * @copyright 2016 Tridium, Inc. All Rights Reserved.
 */

/**
 * @private
 * @module nmodule/webEditors/rc/wb/mgr/commands/DiscoverCommand
 */
define(['bajaux/commands/Command'], function (
        Command) {

  'use strict';

  /**
   * Command type for kicking off the learn process on a manager view.
   *
   * @private
   * @class
   * @extends module:bajaux/commands/Command
   * @alias module:nmodule/webEditors/rc/wb/mgr/commands/DiscoverCommand
   * @param {module:nmodule/webEditors/rc/wb/mgr/MgrLearn} manager
   */
  var DiscoverCommand = function DiscoverCommand(manager) {

    Command.call(this, {
      module: 'webEditors',
      lex: 'commands.mgr.discover',

      /**
       * Call the discover() function on the manager. This will in turn call
       * the user provided doDiscover() function.
       *
       * @alias module:nmodule/webEditors/rc/wb/mgr/commands/DiscoverCommand#invoke
       * @returns {Promise}
       */
      func: function () {
        return manager.discover();
      }
    });
  };

  DiscoverCommand.prototype = Object.create(Command.prototype);
  DiscoverCommand.prototype.constructor = DiscoverCommand;

  return DiscoverCommand;
});
